unit PPDraw;

// 26.08.01 - added flexible label formats, removed broken PatBlt (tris didn't rotate in Visio)

interface

uses Windows, SysUtils, Graphics, v_lib;

procedure DrawPPOnCanvas(pp:patchprofile_p;Canvas:TCanvas;Width,Height:integer;split:integer);

implementation

uses ChooseMdlUnit, FormatDlg;

procedure vec2PerpendicularLine(var d1,d2,da,p1,p2:vec2_t;len,offset:vec_t;split:integer);
var
  db : vec2_t;
  ofs : vec2_t;
begin
  vec2Sub(da,p2,p1);
  // -a2, a1
  d1[0]:=-da[1];
  d1[1]:=da[0];
  len:=len/2;
  vec2Unit(d1,d1);
  vec2Scale(ofs,d1,offset);
  vec2Scale(da,da,1/split);
  vec2Scale(db,d1,len);
  vec2Add(p1,p1,ofs);
  vec2Add(p2,p2,ofs);
  vec2Add(d2,p1,db);
  vec2Sub(d1,p1,db);
end;

procedure DrawPPOnCanvas(pp:patchprofile_p;Canvas:TCanvas;Width,Height:integer;split:integer);
const
  LabelA : string = '';
  LabelB : string = 'B';
  LabelC : string = 'C';
var
  i,j,k,l : integer;
  clist : i_32_array_p;
  xb,yb:vec3_t;
  x,y,dx,dy:vec2_t;
  abc : vec3_t_array_p;
  lt : array[0..127] of char;
  plt : pchar;
const
  scales_dist : vec_t = 10;
  procedure DrawGridDir(Dest:TCanvas;x1,y1,x2,y2,x3,y3:vec_t;split:integer);
  var
    i : integer;
  begin
    // 1 -> 2-3
    dx[0]:=(x2-x1)/(split+1);
    dy[0]:=(y2-y1)/(split+1);
    dx[1]:=(x3-x1)/(split+1);
    dy[1]:=(y3-y1)/(split+1);
    x[0]:=x1+dx[0];y[0]:=y1+dy[0];
    x[1]:=x1+dx[1];y[1]:=y1+dy[1];
    for i:=1 to split do begin
      Dest.MoveTo(round(x[0]),round(y[0]));
      Dest.LineTo(round(x[1]),round(y[1]));
      x[0]:=x[0]+dx[0];
      y[0]:=y[0]+dy[0];
      x[1]:=x[1]+dx[1];
      y[1]:=y[1]+dy[1];
    end;
  end; // DrawGridDir;
  procedure DrawLabel(Dest:TCanvas;x,y:vec_t;val:pChar);
  var
    w,h:vec_t;
  begin
    w:=Dest.TextWidth(val)/2.0;
    h:=Dest.TextHeight(val)/2.0;
    Dest.TextOut(round(x-w),round(y-h),val);
  end; // DrawLabel
var
  p1,p2,p,d1,d2,da : vec2_t;
  s : string;
  len : vec_t;
  ofs : vec_t;
  Bound  : array[0..3] of TPoint;
  v1a,v1b,v1c,v2a,v2b,v2c,dva,dvb,dvc:vec_t;
const
  disdiv : vec_t = 20;
  lendiv : vec_t = 2;
begin
  abc:=@ChooseMdlParamsDialog.abc;
  with Canvas do
  begin
    for i:=0 to 2 do begin
      xb[i]:=pp^.base[i][0];
      yb[i]:=pp^.base[i][1];
    end;
    if FormatDialog.CBFillB.Checked then begin
      Brush.Color:=FormatDialog.BackBox.Brush.Color;
      Windows.PatBlt(Handle,0,0,Width,Height,PATCOPY);
    end; { 26.08.01
    else
      Windows.PatBlt(Handle,0,0,Width,Height,WHITENESS); }
    // Triangle
    if FormatDialog.CBBound.Checked then begin
      Pen.Width:=FormatDialog.SEBoundW.Value;
      Pen.Color:=FormatDialog.BoundBox.Brush.Color;
      for i:=0 to 3 do begin
        Bound[i].x:=round(xb[i mod 3]);
        Bound[i].y:=round(yb[i mod 3]);
      end;
      if FormatDialog.CBFill.Checked then begin
        Brush.Color:=FormatDialog.FillBox.Brush.Color;
        Windows.Polygon(Handle,Bound,3);
      end
      else
        Windows.Polyline(Handle,Bound,4);
    end;
    // Grid lines
    if FormatDialog.CBGrid.Checked then begin
      Pen.Width:=FormatDialog.SEGridW.Value;
      Pen.Color:=FormatDialog.GridBox.Brush.Color;
      DrawGridDir(Canvas,xb[0],yb[0],xb[1],yb[1],xb[2],yb[2],split);
      DrawGridDir(Canvas,xb[1],yb[1],xb[2],yb[2],xb[0],yb[0],split);
      DrawGridDir(Canvas,xb[2],yb[2],xb[0],yb[0],xb[1],yb[1],split);
    end;
    // Isolines
    Pen.Width:=FormatDialog.SELineW.Value;
    Pen.Color:=FormatDialog.LineBox.Brush.Color;
    for i:=0 to pp^.splits-1 do begin
      if pp^.wires = nil then continue;
      for j:=0 to pp^.wires[i]^.numchains-1 do begin
        clist:=pp^.wires[i]^.clist^[j];
        MoveTo(
          round(pp^.wires[i]^.vlist^[clist^[0]][0]),
          round(pp^.wires[i]^.vlist^[clist^[0]][1]));
        for k:=1 to pp^.wires[i]^.numvert^[j]-1 do begin
          LineTo(
            round(pp^.wires[i]^.vlist^[clist^[k]][0]),
            round(pp^.wires[i]^.vlist^[clist^[k]][1]));
        end; // for k
        // line labels
        if FormatDialog.CBTics.Checked then begin
          Font:=FormatDialog.TicsFontDialog.Font;
          if (pp^.wires[i]^.llist[j].flags and LF_NOLABEL) = 0 then
          begin
            // hack - reformat line labels
            StrCopy(lt,pp^.wires[i]^.llist[j].text);
            plt := lt;
            while plt^ <> #0 do
            begin
              if plt^ = '.' then plt^:=',';
              plt:=plt + 1;
            end;
            DrawLabel(Canvas,
              pp^.wires[i]^.llist[j].center[0],
              pp^.wires[i]^.llist[j].center[1],
              PChar(Format(FormatDialog.STicksForm.Text,[StrToFloat(lt)])));
          end;
        end;
      end; // for j
    end; // for i
    // Scales
    if FormatDialog.CBAxes.Checked then begin
      Pen.Width:=FormatDialog.SEAxesW.Value;
      Pen.Color:=FormatDialog.AxesBox.Brush.Color;
      Font:=FormatDialog.LabelFontDialog.Font;
      Brush.Color:=FormatDialog.BackBox.Brush.Color;
      //  :  A  B
      //      (C)
      v1a:=abc^[0][0]; // a -   
      v1b:=abc^[0][1]; // b -   
      v2a:=abc^[1][0]; // a -   
      v2b:=abc^[1][1]; // b -   
      dva:=(v2a-v1a)/(split+1); //   a
      dvb:=(v2b-v1b)/(split+1); //   b
      p1[0]:=xb[0];
      p1[1]:=yb[0];
      p2[0]:=xb[1];
      p2[1]:=yb[1];
      vec2Sub(p,p2,p1);
      ofs:=vec2Abs(p)/disdiv;
      len:=ofs/lendiv;
      vec2PerpendicularLine(d1,d2,da,p1,p2,len,-ofs,split+1);
      Pen.Width:=2;
      MoveTo(round(p1[0]),round(p1[1]));
      LineTo(round(p2[0]),round(p2[1]));
      Ellipse(round(p1[0]-2),round(p1[1]-2),round(p1[0]+2),round(p1[1]+2));
      Ellipse(round(p2[0]-2),round(p2[1]-2),round(p2[0]+2),round(p2[1]+2));
      Pen.Width:=1;
      for i:=1 to split do
      begin
        vec2Add(d1,d1,da);
        vec2Add(d2,d2,da);
        MoveTo(round(d1[0]),round(d1[1]));
        LineTo(round(d2[0]),round(d2[1]));
        if FormatDialog.CBLabels.Checked then begin
          v1a:=v1a+dva;
          v1b:=v1b+dvb;
          s:=Format(FormatDialog.SLabForm.Text,[v1a]);
          TextOut(round(d1[0]),round(d1[1]-TextHeight(s)),s);
          s:=Format(FormatDialog.SLabForm.Text,[v1b]);
          TextOut(round(d2[0]-TextWidth(s)),round(d2[1]),s);
        end;
      end;
      //   ( B  C)
      //    (A)
      v1b:=abc^[1][1]; // b -   
      v1c:=abc^[1][2]; // c -   
      v2b:=abc^[2][1]; // b -   
      v2c:=abc^[2][2]; // c -   
      dvb:=(v2b-v1b)/(split+1); //   b
      dvc:=(v2c-v1c)/(split+1); //   c
      p1[0]:=xb[1];
      p1[1]:=yb[1];
      p2[0]:=xb[2];
      p2[1]:=yb[2];
      vec2Sub(p,p2,p1);
      ofs:=vec2Abs(p)/disdiv;
      len:=ofs/lendiv;
      vec2PerpendicularLine(d1,d2,da,p1,p2,len,-ofs,split+1);
      Pen.Width:=2;
      MoveTo(round(p1[0]),round(p1[1]));
      LineTo(round(p2[0]),round(p2[1]));
      Ellipse(round(p1[0]-2),round(p1[1]-2),round(p1[0]+2),round(p1[1]+2));
      Ellipse(round(p2[0]-2),round(p2[1]-2),round(p2[0]+2),round(p2[1]+2));
      Pen.Width:=1;
      for i:=1 to split do
      begin
        vec2Add(d1,d1,da);
        vec2Add(d2,d2,da);
        MoveTo(round(d1[0]),round(d1[1]));
        LineTo(round(d2[0]),round(d2[1]));
        if FormatDialog.CBLabels.Checked then begin
          v1b:=v1b+dvb;
          v1c:=v1c+dvc;
          s:=Format(FormatDialog.SLabForm.Text,[v1b]);
          TextOut(round(d1[0]-TextWidth(s)/2),round(d1[1]),s);
          s:=Format(FormatDialog.SLabForm.Text,[v1c]);
          TextOut(round(d2[0]-TextWidth(s)/2),round(d2[1]-TextHeight(s)),s);
        end;
      end;
      //  :    A
      //    (B)
      v1a:=abc^[2][0]; // a -   
      v1c:=abc^[2][2]; // c -   
      v2a:=abc^[0][0]; // a -   
      v2c:=abc^[0][2]; // c -   
      dva:=(v2a-v1a)/(split+1); //   a
      dvc:=(v2c-v1c)/(split+1); //   c
      p1[0]:=xb[2];
      p1[1]:=yb[2];
      p2[0]:=xb[0];
      p2[1]:=yb[0];
      vec2Sub(p,p2,p1);
      ofs:=vec2Abs(p)/disdiv;
      len:=ofs/lendiv;
      vec2PerpendicularLine(d1,d2,da,p1,p2,len,-ofs,split+1);
      Pen.Width:=2;
      MoveTo(round(p1[0]),round(p1[1]));
      LineTo(round(p2[0]),round(p2[1]));
      Ellipse(round(p1[0]-2),round(p1[1]-2),round(p1[0]+2),round(p1[1]+2));
      Ellipse(round(p2[0]-2),round(p2[1]-2),round(p2[0]+2),round(p2[1]+2));
      Pen.Width:=1;
      for i:=1 to split do
      begin
        vec2Add(d1,d1,da);
        vec2Add(d2,d2,da);
        MoveTo(round(d1[0]),round(d1[1]));
        LineTo(round(d2[0]),round(d2[1]));
        if FormatDialog.CBLabels.Checked then begin
          v1c:=v1c+dvc;
          v1a:=v1a+dva;
          s:=Format(FormatDialog.SLabForm.Text,[v1c]);
          TextOut(round(d1[0]-TextWidth(s)),round(d1[1]-TextHeight(s)),s);
          s:=Format(FormatDialog.SLabForm.Text,[v1a]);
          TextOut(round(d2[0]),round(d2[1]),s);
        end;
      end;
      // Labels
      Font:=FormatDialog.TicsFontDialog.Font;
      Font.Size:=Font.Size + 2;

      TextOut(round(xb[0]-TextWidth(LabelA)/2),round(yb[0] - TextHeight(LabelA)),LabelA);
      TextOut(round(xb[1]),round(yb[1]),LabelB);
      TextOut(round(xb[2]-TextWidth(LabelC)),round(yb[2]),LabelC);

      Font.Size:=Font.Size - 2;

    end;
  end; // with
end;

end.

