unit misc;

interface

uses Classes,StdCtrls,SysUtils,Forms,Spin,v_lib;

function  ValidateSpinEdit(Edit:TObject;Parent:TForm):Boolean;
function  ValidateFloatEdit(Edit:TObject;Parent:TForm;Res:vec_p):Boolean;

implementation

function  ValidateSpinEdit(Edit:TObject;Parent:TForm):Boolean;
var
  E : TSpinEdit;
begin
  if Edit is TSpinEdit then begin
    E:=TSpinEdit(Edit);
      try
        StrToInt(E.Text);
        if (E.Value<E.MinValue) or (E.Value>E.MaxValue) then
          raise EConvertError.Create('Wrong edit value !');
      except
        on EConvertError do begin
          E.Value:=E.MinValue;
          if Parent<>nil then
            Parent.ActiveControl:=E;
          Result:=False;
          exit;
        end;
      end;
  end;
  Result:=True;
end;

function  ValidateFloatEdit(Edit:TObject;Parent:TForm;Res:vec_p):Boolean;
var
  val : vec_t;
  E : TEdit;
begin
  if Edit is TEdit then begin
    E:=TEdit(Edit);
    try
      val:=StrToFloat(E.Text);
      if Res<>nil then
        Res^:=val;
    except
      on EConvertError do begin
        E.Text:='0,0';
        if Parent<>nil then
          Parent.ActiveControl:=E;
        Result:=False;
        exit;
      end;
    end;
  end;
  Result:=True;
end;

end.
